#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "m68k.h"
#include "doorsos.h"
#include "objimage.h"
#include "link.h"

extern int nbsym,nbrel,nbok;
extern int snb;
extern struct external_reloc *rel;
extern struct external_filehdr *hdr;
extern struct external_scnhdr *scnhdr; // section header
extern struct external_syment *symb;   // symbol
extern struct external_reloc *rel;     // reloc entry
extern char *strtable;                 // String Table

int curhk=0;
hunk **hunks=0;

int iprv = 0;
int ipub = 0;
int iunr = 0;
int ibss = 0;

/********************************************
* append_object(dest, src)
* concatene src  dest.
********************************************/
objimage* append_object(objimage* dest, objimage* src)
{
 int i,j,k,s;
 int offset,srcnb,destnb;
 int error=0;
 /*      preparer fusion des .bss

 modifier les offsets des rel .bss des 2 sections
 changer la taille de la section         */

 int rel_sizes[2];
 int abs_sizes[2];
 rel_sizes[0] = dest->sections[CODE].size;  // taille de la section CODE
 rel_sizes[1] = dest->sections[DATA].size;  // taille de la section DATA

 abs_sizes[0] = dest->sections[CODE].size;
 abs_sizes[1] = dest->sections[DATA].size + dest->sections[DATA].size;

           // CHECKS THAT NO PUBLIC SYMBOL IS DEFINED MORE THAN ONCE //

 for (i=0;i<dest->symbs.nb_pub;i++)
 {
  char *str = dest->symbs.pub_sym[i]->name;
  for (j=0;j<src->symbs.nb_pub;j++)
   if (!strcmp(str,src->symbs.pub_sym[j]->name))
   {
    fprintf(stderr,"Error: multiple definition of '%s'\n",str);
    error = 1;
   }
 }
 if (error)
  return 0;
                        // SECTIONS BSS //

 offset = dest->sections[BSS].size; // taille a ajouter
 for (i=CODE;i<BSS;i++)
   for (j=0;j<src->sections[i].rel.nb_bss;j++)     // pour toutes les rel vers BSS
   {
     ulong *valptr = (ulong*)(src->sections[i].raw+src->sections[i].rel.bss[j]->offset);
     *valptr = rul(rul(*valptr)+offset);
/*     ulong ln = rul(*(ulong*)(src->sections[i].raw+src->sections[i].rel.bss[j]->offset));
     *(ulong*)(src->sections[i].raw+src->sections[i].rel.bss[j]->offset) = rul(size+ln); */
   }
 dest->sections[BSS].size += src->sections[BSS].size; // ajoute les tailles BSS

 /*     preparer fusion des .text et .data

  modifier les offsets ds syms prv, pub
  mofifier les 2 offsets ds rel prv, bss, unr de .text
  fusionner les rel
                                   */

 for (s=CODE;s<BSS;s++)   // pour les 2 sections
 {
                // modifies les offsets de reloc des symbs publiques //

  for (i=0;i<src->symbs.nb_pub;i++)
  {
   if (src->symbs.pub_sym[i]->section == s+1)
    src->symbs.pub_sym[i]->offset += abs_sizes[s];  // A verifier : marche pour s=0
  }
                /* ajoute aux offsets des rel prv, unr, bss
                   et fusionne les rel */

                  // rel prv //

  destnb = dest->sections[s].rel.nb_prv;
  srcnb  = src->sections[s].rel.nb_prv;
  dest->sections[s].rel.prv = re_alloc(dest->sections[s].rel.prv,4*(destnb+srcnb));

  for (j=0;j<destnb;j++)  // pour les rel du dest
  {
   ulong* ln = (ulong *)(dest->sections[s].raw + dest->sections[s].rel.prv[j]->offset);

   if (dest->sections[s].rel.prv[j]->section == 2)  // si reloge depuis une .data
    *ln = rul((rul(*ln)+src->sections[CODE].size)); // Correct
  }

  for (j=0;j<srcnb;j++)
  {
    ulong* ln = (ulong *)(src->sections[s].raw + src->sections[s].rel.prv[j]->offset );

    *ln = rul(rul(*ln)+abs_sizes[src->sections[s].rel.prv[j]->section-1]);

    src->sections[s].rel.prv[j]->offset += rel_sizes[s];
    dest->sections[s].rel.prv[j+destnb] = src->sections[s].rel.prv[j];
  }
  free (src->sections[s].rel.prv);
  dest->sections[s].rel.nb_prv = destnb+srcnb;

                  // rel unr //

  destnb = dest->sections[s].rel.nb_unr;
  srcnb = src->sections[s].rel.nb_unr;
  dest->sections[s].rel.unr = re_alloc(dest->sections[s].rel.unr,4*(destnb+srcnb));
  for (j=0;j<srcnb;j++)
  {
   src->sections[s].rel.unr[j]->offset += rel_sizes[s];
   dest->sections[s].rel.unr[j+destnb] = src->sections[s].rel.unr[j];
  }
  free (src->sections[s].rel.unr);
  dest->sections[s].rel.nb_unr = destnb+srcnb;

                  // rel bss //

  destnb = dest->sections[s].rel.nb_bss;
  srcnb = src->sections[s].rel.nb_bss;
  dest->sections[s].rel.bss = re_alloc(dest->sections[s].rel.bss,4*(destnb+srcnb));
  for (j=0;j<srcnb;j++)
  {
   src->sections[s].rel.bss[j]->offset += rel_sizes[s];
   dest->sections[s].rel.bss[j+destnb] = src->sections[s].rel.bss[j];
  }
  free (src->sections[s].rel.bss);
  dest->sections[s].rel.nb_bss = destnb+srcnb;
 }


         //      fusionne les syms..            //

 for (i=0;i<dest->symbs.nb_pub;i++)
 {
  if (dest->symbs.pub_sym[i]->section == 2)
   dest->symbs.pub_sym[i]->offset += src->sections[0].size;
 }



                // Syms pub //

 k = dest->symbs.nb_pub;
 dest->symbs.pub_sym = re_alloc(dest->symbs.pub_sym,4*(k+src->symbs.nb_pub));
 for (i=0;i<src->symbs.nb_pub;i++)
  dest->symbs.pub_sym[k+i] = src->symbs.pub_sym[i];
 free (src->symbs.pub_sym);
 dest->symbs.nb_pub += src->symbs.nb_pub;

                // Syms unr //

 k = dest->symbs.nb_unr;
 dest->symbs.unr_sym = re_alloc(dest->symbs.unr_sym,4*(k+src->symbs.nb_unr));
 for (i=0;i<src->symbs.nb_unr;i++)
  dest->symbs.unr_sym[k+i] = src->symbs.unr_sym[i];
 free (src->symbs.unr_sym);
 dest->symbs.nb_unr += src->symbs.nb_unr;

                // Syms bss //

 k = dest->symbs.nb_bss;

 dest->symbs.bss_sym = re_alloc(dest->symbs.bss_sym,4*(k+src->symbs.nb_bss));
 for (i=0;i<src->symbs.nb_bss;i++)
  dest->symbs.bss_sym[k+i] = src->symbs.bss_sym[i];
 free (src->symbs.bss_sym);
 dest->symbs.nb_bss += src->symbs.nb_bss;

 /*      fusionne le contenu des 2 objets */

 for (i=0;i<2;i++) // fusionner .text et .data
 {
  int srcsize = src->sections[i].size;
  int destsize = dest->sections[i].size;
  dest->sections[i].raw = re_alloc(dest->sections[i].raw,srcsize+destsize);
  memcpy(dest->sections[i].raw+destsize,src->sections[i].raw,srcsize);
  dest->sections[i].size += srcsize;
  free(src->sections[i].raw);
 }
 free(src);

 /* Resoudre si possible les unresolved

     - Verifier que les publics ne sont pas
       definis plusieurs fois, sinon -> message

     - pour chak rel unresolved, chercher le public
       ki lui correspond

       si on trouve, on transforme le rel unr en
       rel prv                        */



          // DETECTS ALL UNRESOLVED SYMS WHICH CAN BE RESOLVED TO PUBLICS //

 for (i=0;i<dest->symbs.nb_unr;i++)
 {
  unresolved* unr = dest->symbs.unr_sym[i];
  for (j=0;j<dest->symbs.nb_pub;j++)
    if (!strcmp(unr->name,dest->symbs.pub_sym[j]->name))
    {
     unr->enabled = 0;            // desactive unresolved sym
     unr->pubsection = dest->symbs.pub_sym[j]->section;
     unr->puboffs = dest->symbs.pub_sym[j]->offset;
    }
 }

          // RESOLVES RELOCATIONS //

 for (i=0;i<2;i++)
   for (j=0;j<dest->sections[i].rel.nb_unr;j++)
     if (dest->sections[i].rel.unr[j]->sym->enabled == 0) // si on peut resoudre
     {
       sct_rel* rel = &dest->sections[i].rel;
       rel->nb_prv++;
       rel->prv = re_alloc(rel->prv,4*rel->nb_prv);
       rel->prv[rel->nb_prv-1] = alloc(sizeof(prv_rel));
       rel->prv[rel->nb_prv-1]->offset = rel->unr[j]->offset;
       rel->prv[rel->nb_prv-1]->section = rel->unr[j]->sym->pubsection;
       *(ulong*)(dest->sections[i].raw+rel->unr[j]->offset) = rul(rel->unr[j]->sym->puboffs);
     }

 return dest;
}

        /* deletes an objimage */

void delete_objimage(objimage* obj)
{
 int i;
 sct_sym symbs = obj->symbs;
 for (i=0;i<2;i++)         // Pour les sections .text et .data
 {
  int j;
  section* sec = &obj->sections[i];
  free (sec->raw);                // free le raw

  for (j=0;j<sec->rel.nb_prv;j++) // reloc private
   free (sec->rel.prv[j]);
  free (sec->rel.prv);

  for (j=0;j<sec->rel.nb_unr;j++) // reloc unresolved
   free (sec->rel.unr[j]);
  free (sec->rel.unr);

  for (j=0;j<sec->rel.nb_bss;j++) // reloc bss
   free (sec->rel.bss[j]);
  free (sec->rel.bss);
 }

   // Free la symbol table

 for (i=0;i<symbs.nb_pub;i++)
 {
  free (symbs.pub_sym[i]->name);
  free (symbs.pub_sym[i]);
 }
 free (symbs.pub_sym);

 for (i=0;i<symbs.nb_unr;i++)
 {
  free (symbs.unr_sym[i]->name);
  free (symbs.unr_sym[i]);
 }
 free (symbs.unr_sym);

 for (i=0;i<symbs.nb_bss;i++)
 {
  free (symbs.bss_sym[i]->name);
  free (symbs.bss_sym[i]);
 }
 free (symbs.bss_sym);

 free (obj);    // free le pointer
}

/* translate_object
 Translates a COFF or AmigaDOS object to an internal format */

objimage *translate_object(objfile *object)
{

 objimage *obj;
 section *sct;                    // structure section
 int i,j,k,l,nb;
 obj = alloc(sizeof(objimage));  // alloue l'objet image

 if (object->type == COFF)
 {

// Alloue la symbol Table et la remplit
  hdr  = object->raw;
  nbsym= rul(hdr->f_nsyms);
  symb = object->raw+rul(hdr->f_symptr);
  strtable = (char *)(symb) + nbsym*SYMESZ;

  nb = nb_pub_sym(object);
  obj->symbs.nb_pub=nb;
  obj->symbs.pub_sym=0;
  if(nb)
  {
   obj->symbs.pub_sym=alloc(4*nb);
   for (j=0;j<nb;j++)
   {
    obj->symbs.pub_sym[j] = alloc(sizeof(spublic));   // Alloue pour les syms publics
   }
  }

  nb = nb_unr_sym(object);
  obj->symbs.nb_unr=nb;
  obj->symbs.unr_sym=0;
  if(nb)
  {
   obj->symbs.unr_sym=alloc(4*nb);
   for (j=0;j<nb;j++)
   {
    obj->symbs.unr_sym[j] = alloc(sizeof(unresolved));// Alloue pour les syms unresolved
   }
  }

  nb = nb_bss_sym(object);
  obj->symbs.nb_bss=nb;
  obj->symbs.bss_sym=0;
  if (nb)
  {
   obj->symbs.bss_sym=alloc(4*nb);
   for (j=0;j<nb;j++)
   {
    obj->symbs.bss_sym[j] = alloc(sizeof(bsssym));// Alloue pour les syms unresolved
   }
  }

                 // REMPLISSAGE DE LA TABLE DE SYMBOLES //

  hdr  = object->raw;
  nbsym= rul(hdr->f_nsyms);
  symb = object->raw+rul(hdr->f_symptr);
  strtable = (char *)(symb) + nbsym*SYMESZ;

  ipub = ibss = iunr = 0;
  for (i=0;i<nbsym;i++,symb=(char *)(symb)+18)          // Cherche dans tous les symbols
  {
   if(is_sym_pub(symb))                 // si symbole public
   {
    obj->symbs.pub_sym[ipub]->section= rus(symb->e_scnum);  // charge le N de section
    obj->symbs.pub_sym[ipub]->offset = rul(symb->e_value);  // offset
    obj->symbs.pub_sym[ipub]->symindex= i;
    obj->symbs.pub_sym[ipub]->name = get_sym_name(symb);
    ipub++;
    continue;
   }

   if(is_sym_unr(symb))                 // si symbole unresolved
   {
    obj->symbs.unr_sym[iunr]->symindex= i;
    obj->symbs.unr_sym[iunr]->enabled = 1;
    obj->symbs.unr_sym[iunr]->name = get_sym_name(symb);
    iunr++;
    continue;
   }

   if(is_sym_bss(symb))                 // si symbole bss
   {
    obj->symbs.bss_sym[ibss]->size = rul(symb->e_value);  // taille du bloc
    obj->symbs.bss_sym[ibss]->symindex= i;
    obj->symbs.bss_sym[ibss]->name = get_sym_name(symb);
    ibss++;
    continue;
   }
  }

                // TABLE DE SYMBOLES CHARGEE //

  scnhdr = object->raw+FILHSZ;

  for (snb=0;snb<2;snb++,scnhdr++)      // POUR .TEXT ET .DATA //
  {
   int base_offset = rul(scnhdr->s_paddr); // Adresse dans le fichier virtuel
   i = rul(scnhdr->s_size);
   sct = &obj->sections[snb];               // fait pointer sct

   sct->size= (ushort)i;                  // taille de la section
   sct->raw = alloc(i);                   // alloue pour le raw de la section
   memcpy(sct->raw, object->raw+rul(scnhdr->s_scnptr), i); // copie le raw


               // ALLOUE L'ARBRE DES RELOCATIONS //

   nb = nb_prv_rel(scnhdr,object);
   sct->rel.nb_prv=nb;
   sct->rel.prv=0;
   if (nb)
   {
    sct->rel.prv=alloc(4*nb);
    for (j=0;j<nb;j++)
     sct->rel.prv[j] = alloc(sizeof(prv_rel));
   }

   nb = nb_unr_rel(scnhdr,object);
   sct->rel.nb_unr=nb;
   sct->rel.unr=0;
   if (nb)
   {
    sct->rel.unr=alloc(4*nb);
    for (j=0;j<nb;j++)
     sct->rel.unr[j] = alloc(sizeof(unr_rel));
   }

   nb = nb_bss_rel(scnhdr,object);
   sct->rel.nb_bss=nb;
   sct->rel.bss=0;
   if (nb)
   {
    sct->rel.bss=alloc(4*nb);
    for (j=0;j<nb;j++)
     sct->rel.bss[j] = alloc(sizeof(bss_rel));
   }

   hdr  = object->raw;
   nbsym= rul(hdr->f_nsyms);
   symb = object->raw+rul(hdr->f_symptr);        // pointe vers la table de sym
   nbrel = rus(scnhdr->s_nreloc);
   rel = object->raw+rul(scnhdr->s_relptr);      // pointe vers la table de reloc de la section

   iprv = iunr = ibss = 0;
   for (j=0;j<nbrel;j++,rel=(char *)(rel)+10)
   {
    struct external_syment* sym = (char *)symb+18*rul(rel->r_symndx);

    if (is_sym_sec(sym) || is_sym_pub(sym) )
    {
     prv_rel* prv;
     prv = obj->sections[snb].rel.prv[iprv];
     prv->offset = rul(rel->r_vaddr) - base_offset;    // offset DANS la section
     prv->section = rus(sym->e_scnum);
     iprv++;
     continue;
    }

    if (is_sym_unr(sym))
    {
     unr_rel* unr;
     unr = obj->sections[snb].rel.unr[iunr];
     unr->offset = rul(rel->r_vaddr)-base_offset;
     unr->type = 0;
     for (k=0;k<obj->symbs.nb_unr;k++)
     {
      if (obj->symbs.unr_sym[k]->symindex == rul(rel->r_symndx))
      {
       unr->sym = obj->symbs.unr_sym[k];
       break;
      }
     }
     iunr++;
     continue;
    }

    if (is_sym_bss(sym))
    {
     bss_rel* bss;
     bss = obj->sections[snb].rel.bss[ibss];
     bss->offset = rul(rel->r_vaddr)-base_offset;             // offset dans le bloc
     for (k=0;k<obj->symbs.nb_bss;k++)
     {
      if (obj->symbs.bss_sym[k]->symindex == rul(rel->r_symndx))
      {
       bss->sym = obj->symbs.bss_sym[k];
       break;
      }
     }
     ibss++;
     continue;
    }
   }
  }

                      // Construire la section BSS //

  i = 0;               // taille section BSS = 0 //

  for (j=0;j<obj->symbs.nb_bss;j++)
  {
   bsssym* bss = obj->symbs.bss_sym[j];   // initialise bss
   for (l=0;l<2;l++)
   {
    for (k=0;k<obj->sections[l].rel.nb_bss;k++)
    {
     if (obj->sections[l].rel.bss[k]->sym == bss) // si c ce symbole BSS
     {
      ulong ln = rul(*(ulong*)(obj->sections[l].raw+obj->sections[l].rel.bss[k]->offset));
      *(ulong*)(obj->sections[l].raw+obj->sections[l].rel.bss[k]->offset) = rul(i+ln);
      obj->sections[l].rel.bss[k]->sym = obj->symbs.bss_sym[0];  // le fait pointer sur le 1 sym BSS
     }
    }
   }
   i+=bss->size;
  }

  obj->sections[2].size=i;              // Taille de la section BSS

  return obj;
 }


 else  // si c un amiga dos
 {
  ulong* ptr = object->raw;
  hunk* hk;
  int size;
  int nbhunks=0;
  int hunksnb[3]= {0,0,0};

  int codesize=0;
  int datasize=0;
  int bsssize=0;
  hunks=0;
  curhk=0;

        // preparer les bases de l'obj //
  obj = create_objimage();

                   /* PASS 1:
                      - check that all hunks are valid
                      - load some infos about the CODE, DATA & BSS Hunks
                        used in PASS 2        */

  while (1)
  {
   int k = rul(*ptr++);    // lit le hunk type
   switch (k)
   {
    case HunkUnit:   // je sais pas trop
     ptr++;
     break;
    case HunkName:
     ptr += rul(*ptr++); // skip it
     break;
    case HunkCode:
     nbhunks++;          // nb hunks++
     hunksnb[0]++;       // nb hunks code ++
     hunks = re_alloc(hunks,4*nbhunks); // re alloue
     hunks[nbhunks-1] = alloc(sizeof(hunk));

     hk = hunks[nbhunks-1];
     hk->type = CODE;
     hk->no = nbhunks-1;
     hk->size = 4*rul(*ptr);
     hk->offset = codesize;
     codesize += hk->size;

     ptr = check_am_sec(ptr,object); // verifie ke le hunk est OK.
     break;

    case HunkData:
     nbhunks++;          // nb hunks++
     hunksnb[1]++;       // nb hunks code ++
     hunks = re_alloc(hunks,4*nbhunks); // re alloue
     hunks[nbhunks-1] = alloc(sizeof(hunk));

     hk = hunks[nbhunks-1];
     hk->type = DATA;
     hk->no = nbhunks-1;
     hk->size = 4*rul(*ptr);
     hk->offset = datasize;
     datasize += hk->size;
     ptr = check_am_sec(ptr,object); // verifie ke le hunk est OK.
     break;

    case HunkBSS:
     nbhunks++;          // nb hunks++
     hunksnb[2]++;       // nb hunks code ++
     hunks = re_alloc(hunks,4*nbhunks); // re alloue
     hunks[nbhunks-1] = alloc(sizeof(hunk));

     hk = hunks[nbhunks-1];
     hk->type = BSS;
     hk->no = nbhunks-1;
     hk->size = 4*rul(*ptr++);
     hk->offset = bsssize;
     bsssize += hk->size;
     if (rul(*ptr++) != HunkEnd)
     {
      fprintf(stderr,"Error: unrecognized BSS section in %s\n",object->name);
      return 0;
     }
     break;

    default:
     fprintf(stderr,"Error: unrecognized Hunk %d in %s\n",k,object->name);
     return 0;
   }
   if (!ptr)  // si erreur
    return 0; // renvoie ptr sur rien.
   if (ptr == object->raw+object->size)
    break;
   continue;    // sinon continue !
  }

                   /* PASS 2:
                      - translate the object
                        used in PASS 2        */

  ptr = object->raw;    // Re-init ptr

  while (1)
  {
   int k = rul(*ptr++);    // lit le hunk type
   switch (k)
   {
    case HunkUnit:   // je sais pas trop
     ptr++;
     break;
    case HunkName:
     ptr += rul(*ptr++); // skip it
     break;
    case HunkCode:
     size = 4*rul(*ptr);
     obj->sections[0].raw = re_alloc(obj->sections[0].raw,obj->sections[0].size+size);
     memcpy(obj->sections[0].raw+obj->sections[0].size,ptr+1,size);
     ptr += rul(*ptr++);
     obj->sections[0].size += size;
     ptr = load_am_sec(ptr,obj,CODE);
     break;
    case HunkData:
     size = 4*rul(*ptr);
     obj->sections[1].raw = re_alloc(obj->sections[1].raw,obj->sections[1].size+size);
     memcpy(obj->sections[1].raw+obj->sections[1].size,ptr+1,size);
     ptr += rul(*ptr++);
     obj->sections[1].size += size;
     ptr = load_am_sec(ptr,obj,DATA);
     break;

    case HunkBSS:
     obj->sections[2].size += 4*rul(*ptr);
     ptr += 2;
     break;

    default:
     fprintf(stderr,"Error: unrecognized Hunk %d in %s\n",k,object->name);
     return 0;
   }
   if (!ptr)  // si erreur
    return 0; // renvoie ptr sur rien.
   if (ptr == object->raw+object->size)
    break;
   continue;    // sinon continue !
  }

  return obj;
 }
}

long* load_am_sec(long* ptr,objimage* obj,ushort section)
{
 int i,k;
 while (1)
 {
  k = rul(*ptr++);   // lit le hunk
  switch (k)
  {
   case HunkR32:     // reloc 32
    while(1)
    {
     int nbr;   // nb de rel
     int refhk; // hunk auquel ca refere
     ulong offset;
     ulong* ln;

     if (!*ptr)
      break;
     nbr = rul(*ptr++); // nb de rel
     refhk = rul(*(ptr++)); // hunk de reference

     for (i=0;i<nbr;i++)
     {
      offset = rul(*ptr++) + hunks[curhk]->offset ; // offset ou on reloge
      ln = obj->sections[section].raw + offset;
      *ln = rul(rul(*ln)+hunks[refhk]->offset);

      if (hunks[refhk]->type == BSS) // reloc BSS
       add_rel_bss(obj,offset,section);
      else                           // reloc DATA/TEXT
       add_rel_prv(obj,offset,section,hunks[refhk]->type+1);
     }
    }
    ptr++;
    break;           // ok

   case HunkExt:     // reloc externes + syms
    while (1)
    {
     ulong offset;       // Offset
     ushort symsz;       // Taille du sym
     char *name;         // Nom du sym

     ushort type = rus(*ptr);


     if (!*ptr)
      break;

     symsz = 4*(rul(*ptr++) & 0xffff);
     name = alloc(symsz+1);
     memcpy(name,ptr,symsz);  // copie la chaine
     ptr += symsz/4;
     name[symsz] = 0;       // termine la chaine

     if (type&0x8000)                   // si external sym
     {
      ulong nbrel = rul(*ptr++);
      unresolved* unr = add_ext_sym(obj,name);            // Ajoute le symbole
      for (i=0;i<nbrel;i++)
      {
       offset = rul(*ptr++) + hunks[curhk]->offset;
       add_rel_unr(obj,offset,unr,section,type);
      }
     }
     else                               // si public sym
     {
      offset = rul(*ptr++) + hunks[curhk]->offset;
      add_pub_sym(obj,name,offset,section+1);
     }
    }
    ptr++;
    break;

   case HunkSym:     // Syms de debug
    while (1)
    {
     if (!*ptr)
      break;
     ptr += rul(*ptr++);    // Zapps pour l'instant
     ptr++;
    }
    ptr++;
    break;

   case HunkEnd:
    curhk++;
    return ptr;
  }
 }
}


long* check_am_sec(long* ptr,objfile* object)
{
 int error = 0;
 int k;
 ptr += rul(*ptr++);  // avance le ptr
 while (1)
 {
  k = rul(*ptr++);   // lit le hunk
  switch (k)
  {
   case HunkR32:     // reloc 32
    while(1)
    {
     if (!*ptr)
      break;
     ptr+= rul(*ptr++);
     ptr++;
    }
    ptr++;
    break;           // ok

   case HunkR16:     // reloc 16
    while(1)
    {
     if (!*ptr)
      break;
     ptr += rul(*ptr++);
     ptr ++;
    }
    ptr++;
    fprintf(stderr,"16-bits relocation is unsupported (%s)\n",object->name);
    error = 1;
    break;

   case HunkR8:      // reloc 8
    while(1)
    {
     if (!*ptr)
      break;
     ptr += rul(*ptr++);
     ptr ++;
    }
    ptr++;
    fprintf(stderr,"8-bits relocation is unsupported (%s)\n",object->name);
    error = 1;
    break;

   case HunkExt:     // reloc externes + syms
    while (1)
    {
     char *name;
     ushort type = rus(*ptr);
     if (!*ptr)
      break;
     name = (char *)(ptr+1);
     ptr += (rul(*ptr++) & 0xffff);      // skippe le nom..
     if (type&0x8000)                    // si external sym
     {
      ptr += rul(*ptr++);
      if (type==0x8A00)
      {
       if (strncmp("_RAM_CALL_",name,10))
       {
        fprintf(stderr,"16-bits relocation to external symbols is unsupported (%s)\n",object->name);
        error = 1;
       }
      }
      if (type==0x8B00)
      {
       fprintf(stderr,"8-bits relocation to external symbols is unsupported (%s)\n",object->name);
       error = 1;
      }
     }
     else
      ptr++;
    }
    ptr++;
    break;

   case HunkSym:     // Syms de debug
    while (1)
    {
     if (!*ptr)
      break;
     ptr += rul(*ptr++);
     ptr++;
    }
    ptr++;
    break;

   case HunkDbg:     // Utilis ???
    fprintf(stderr,"HunkDbg currently unrecognized (%s)\n",object->name);
    return 0;        // quitte direct

   case HunkEnd:
    if (error)
     return 0;
    else
     return ptr;
  }
 }
}


objimage* create_objimage(void)
{
 int i;
 objimage* obj = alloc(sizeof(objimage));
 obj->symbs.nb_pub = 0;
 obj->symbs.nb_unr = 0;
 obj->symbs.nb_bss = 0;
 obj->symbs.pub_sym= 0;
 obj->symbs.unr_sym= 0;
 obj->symbs.bss_sym= 0;

 obj->sections[2].size = 0;
 for (i=0;i<2;i++)
 {
  section* sec = &obj->sections[i];
  sec->size = 0;
  sec->raw  = 0;
  sec->rel.nb_prv = 0;
  sec->rel.nb_unr = 0;
  sec->rel.nb_bss = 0;
  sec->rel.prv = 0;
  sec->rel.unr = 0;
  sec->rel.bss = 0;
 }
 return obj;
}

void add_rel_prv(objimage* obj, ulong offset, ushort section, ushort destsection)
{
 sct_rel* rel = &obj->sections[section].rel;
 prv_rel** prv;
 int nb = ++rel->nb_prv;
 prv = rel->prv = re_alloc(rel->prv,4*nb);
 prv[nb-1] = alloc(sizeof(prv_rel));
 prv[nb-1]->offset = offset;
 prv[nb-1]->section = destsection;
}

void add_rel_bss(objimage* obj,ulong offset, ushort section)
{
 sct_rel* rel = &obj->sections[section].rel;
 bss_rel** bss;
 int nb = ++rel->nb_bss;
 bss = rel->bss = re_alloc(rel->bss,4*nb);
 bss[nb-1] = alloc(sizeof(bss_rel));
 bss[nb-1]->offset = offset;
 bss[nb-1]->sym = NULL;     // INUTILE avec le AmigaDOS
}

void add_rel_unr(objimage* obj,ulong offset, unresolved* unr, ushort section, ushort type)
{
 sct_rel* rel = &obj->sections[section].rel;
 unr_rel** urel;
 int nb = ++rel->nb_unr;
 urel = rel->unr = re_alloc(rel->unr,4*nb);
 urel[nb-1] = alloc(sizeof(unr_rel));

 urel[nb-1]->offset = offset;
 urel[nb-1]->sym = unr;
 urel[nb-1]->type = (type == 0x8A00) ? 1 : 0;
}

unresolved* add_ext_sym(objimage* obj, char *name)
{
 sct_sym* syms = &obj->symbs;
 unresolved* unr;
 int nb = ++obj->symbs.nb_unr;
 syms->unr_sym = re_alloc(syms->unr_sym,4*nb);
 unr = syms->unr_sym[nb-1] = alloc(sizeof(unresolved));
 name = conv_oldlib_names(name); // converts lib@xxxx to lib__xxxx

 unr->name = name;
 unr->enabled = 1;
 unr->symindex = 0;
 return unr;
}

void add_pub_sym(objimage* obj, char *name, ulong offset, ushort section)
{
 sct_sym* syms = &obj->symbs;
 spublic* pub;
 int nb = ++obj->symbs.nb_pub;
 syms->pub_sym = re_alloc(syms->pub_sym,4*nb);
 pub = syms->pub_sym[nb-1] = alloc(sizeof(spublic));
 name = conv_oldlib_names(name); // converts lib@xxxx to lib__xxxx

 pub->name = name;
 pub->offset = offset;
 pub->section = section;
 pub->symindex = 0;
}

char *conv_oldlib_names(char *name) // converts lib@xxxx to lib__xxxx
{
 int s = strlen(name);
 if ((s<6) || (s>13))
  return name;
 if (name[s-5] != '@')
  return name;
 name = re_alloc(name,s+2);
 memmove(name+s-3,name+s-4,4);
 name[s-5] = '_';
 name[s-4] = '_';
 name[s+1] = 0;
 return name;
}
